package es.uoc.mejoratuingles.activities;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;
import android.webkit.WebView;
import android.widget.Toast;

import es.uoc.mejoratuingles.db.*;
import es.uoc.mejoratuingles.db.adapters.*;


public class LeccionView extends Activity {
	
	//Nuestra vista necesaria para la web
    private WebView mWebView;
    
    private String idLeccion;
    private String nombreLeccion;
    
    private LeccionAdapter leccionAdapter=null;
 
    @Override
    public void onCreate(Bundle icicle) {
        super.onCreate(icicle);
        setContentView(R.layout.leccion_layout);
        
        idLeccion=(String)(getIntent().getExtras()).get("id");
        nombreLeccion=(String)(getIntent().getExtras()).get("nombreLeccion");
        String url=(String)(getIntent().getExtras()).get("url");
        
        String tema="file:///android_asset/"+url;
 
        //asociamos
        mWebView = (WebView) findViewById(R.id.webview);
 
        //cargo un .html que he situado en la carpeta asset/ del proyecto
        mWebView.loadUrl(tema);
    }
    
    
    
    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        getMenuInflater().inflate(R.menu.menu_leccion, menu);
        return true;
    }
    
    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
    	
    	//Bundle b=new Bundle();	
    	//Context contexto=getApplicationContext();

    	Intent intento=null;
    	
    	
        switch (item.getItemId()) {
            case R.id.MnuOpc4:     
            	intento=new Intent(LeccionView.this, ListadoLeccion.class);
            	Log.d("MejoraTuIngles","probando...");
                break;
            case R.id.MnuOpc5:
            	PreguntaCompletarView.inicializar();
            	
                intento=new Intent(LeccionView.this, PreguntaCompletarView.class);
                
                intento.putExtra("idLeccion", idLeccion);
                intento.putExtra("nombreLeccion", nombreLeccion);
                
            	
                break;
            
            case R.id.lecc_terminada:
            	
            	leccionAdapter=new LeccionAdapter(getApplicationContext());
            	leccionAdapter.completada(idLeccion);
            	
                Toast.makeText(this, "Guardado progreso de lecci�n.", Toast.LENGTH_LONG).show();  
                return true;
                
            default:
                return super.onOptionsItemSelected(item);
        }
        
        startActivity(intento);
        
       
        
        return true;
    }
	

}
