package es.uoc.mejoratuingles.activities;


import java.util.*;

import android.os.*;
import android.database.*;
import android.util.*;
import android.view.*;
import android.widget.*;
import android.content.*;
import android.app.ListActivity;

import es.uoc.mejoratuingles.beans.*;
import es.uoc.mejoratuingles.db.*;
import es.uoc.mejoratuingles.db.adapters.*;

public class ListadoLeccion extends ListActivity {
	
	private List<Leccion> m_locals = null;
	private IconListViewAdapter m_adapter;
	private LeccionAdapter leccionAdapter=null;
	
	@Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.listado_leccion);        
        
        
        m_locals=new ArrayList<Leccion>();
        
        this.m_adapter = new IconListViewAdapter(this, R.layout.leccion_item, m_locals);
        setListAdapter(this.m_adapter);  
        
        getLecciones();
        
    }
	
	
    @Override
    protected void onListItemClick(ListView l, View v, int position, long id) {
       // Local local = (Local) l.getItemAtPosition(position);        
       
       // Toast.makeText(this, local.getLocalName(), 
        ///  		Toast.LENGTH_LONG).show();
    	//Intent intent = new Intent(IconListView.this, Museos.class);
		//startActivity(intent);
    	
    	Intent intento=new Intent(ListadoLeccion.this,LeccionView.class);
    	intento.putExtra("id", (m_locals.get(position)).getId());
    	intento.putExtra("nombreLeccion", (m_locals.get(position)).getNombre());
    	intento.putExtra("url",(m_locals.get(position)).getUrl());
    	
    	startActivity(intento);
    	
    	//Toast.makeText(getApplicationContext(), (m_locals.get(position)).getNombre(),  Toast.LENGTH_LONG).show();
    	
    }
	
/*	private void getLecciones(){
    	
    	try {
    		
    		//De palo
    		//adapterPOI=new POIAdapter(getApplicationContext());
    		
    		//adapterPOI.open();
    		
    		Leccion l=new Leccion();
    		l.setNombre("Leccion 1");
    		l.setId("1");
    		
    		Leccion l2=new Leccion();
    		l2.setNombre("Leccion 2");
    		l2.setId("2");
    		
    		//Fin de palo
    		
    		ArrayList<Leccion> lecciones=new ArrayList<Leccion>();
    		lecciones.add(l);
    		lecciones.add(l2);
    		
    		m_locals= lecciones;
    		
          } catch (Exception e) {
            Log.e("BACKGROUND_PROC", e.getMessage());
          }
          
          if(m_locals != null && m_locals.size() > 0){
              for(int i=0;i<m_locals.size();i++)
              m_adapter.add(m_locals.get(i));
          }

          m_adapter.notifyDataSetChanged();       	
    	
    } */
	
	private void getLecciones(){
		try{
			leccionAdapter=new LeccionAdapter(getApplicationContext());
			List<Leccion> lecciones=leccionAdapter.getAllLeccion();
			m_locals= lecciones;
    		
        } catch (Exception e) {
          Log.e("BACKGROUND_PROC", e.getMessage());
        }
        
        if(m_locals != null && m_locals.size() > 0){
            for(int i=0;i<m_locals.size();i++)
            m_adapter.add(m_locals.get(i));
        }

        m_adapter.notifyDataSetChanged(); 
	}
	
	
	 public class IconListViewAdapter extends ArrayAdapter<Leccion> {

	        private List<Leccion> items;

	        public IconListViewAdapter(Context context, int textViewResourceId, List<Leccion> items) {
	                super(context, textViewResourceId, items);
	                this.items = items;
	        }
	        @Override
	        public View getView(int position, View convertView, ViewGroup parent) {
	                View v = convertView;
	                if (v == null) {
	                    LayoutInflater vi = (LayoutInflater)getSystemService(Context.LAYOUT_INFLATER_SERVICE);
	                    v = vi.inflate(R.layout.leccion_item, null);
	                }
	                
	                //Carga de elementos
	                Leccion o = items.get(position);
	                if (o != null) {
	                	
	                	//poblamos la lista de elementos
	                	
	                        TextView tt = (TextView) v.findViewById(R.id.row_toptext);
	                        ImageView im = (ImageView) v.findViewById(R.id.icon);
	                        
	                        if (im!= null) {
	                        	im.setImageResource(R.drawable.icon_avance);
	                        }                        
	                        if (tt != null) {             
	                            tt.setText(o.getNombre());                             
	                        }    	                    	                        
	                }
	                return v;
	        }
	}

}
