package es.uoc.mejoratuingles.activities;


import java.util.*;

import android.os.Bundle;
import android.app.Activity;
import android.content.Intent;
import android.graphics.Color;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.*;
import android.support.v4.app.NavUtils;

import es.uoc.mejoratuingles.beans.*;
import es.uoc.mejoratuingles.db.*;
import es.uoc.mejoratuingles.db.adapters.*;

public class PreguntaCompletarView extends Activity{
	
	public static int numeroPregunta=0;
	public static int numeroEjercicio=0;
	
	public static boolean uPregunta=false;
	public static boolean uEjercicio=false;
	
	public static boolean checkeable=false;
	public static boolean checkMode=false;
	
	public String idLeccion;
	public String nombreLeccion;
	
	Ejercicio ejercicio;
	Pregunta pregunta;
	
	public static Vector<Ejercicio> ejercicios=null; //Contenedor de los ejercicios de una lecci�n
	
	private LeccionAdapter leccionAdapter=null;
	
	TextView txtRespuesta=null;
	
	 @Override

	    public void onCreate(Bundle savedInstanceState) {

	        super.onCreate(savedInstanceState);
	        setContentView(R.layout.pregunta_completar);
	        
	        TextView tema = (TextView)findViewById(R.id.tema);
        	TextView txtEjercicio = (TextView)findViewById(R.id.enunciadoGeneral);
        	TextView datosAdicionales = (TextView)findViewById(R.id.datos_adicionales);
        	TextView txtPregunta = (TextView)findViewById(R.id.pregunta);
        	txtRespuesta= (TextView)findViewById(R.id.respuesta);
        	TextView txtRespuestaCorrecta=(TextView)findViewById(R.id.respuestaCorrecta);
        	ImageView imgIconoRespuesta=(ImageView)findViewById(R.id.iconoCheck);
        	LinearLayout capaRespuesta=(LinearLayout)findViewById(R.id.capaRespuesta);
        	
        	idLeccion=(String)getIntent().getExtras().getString("idLeccion");
        	nombreLeccion=(String)getIntent().getExtras().getString("nombreLeccion");
        	
        	tema.setText(idLeccion+":"+nombreLeccion);
	        
	        //Diferenciar si viene de LeccionView o de PreguntaCompletarView
	        
	        if(ejercicios==null){
	        	Log.d("PreguntaCompletarView","Llego desde la lecci�n");
	        
	        	ejercicios=getEjercicios();       
	        	ejercicio=ejercicios.elementAt(0);
	        
	        	datosAdicionales.setText(ejercicio.getDatosAdicionales());
	        	txtEjercicio.setText(ejercicio.getEnunciado());
	        	
	        	
	        	Vector<Pregunta> preguntas=ejercicio.getPreguntas();
	        	pregunta=preguntas.elementAt(0);
	        	
	        	txtPregunta.setText(pregunta.getEnunciado());
	        	
	        }else{
	        	Log.d("PreguntaCompletarView","Llego desde la paginaci�n");
	        	
	        	//1. Extraemos el n�mero de ejercicio
	        	
	        	try{
	        		ejercicio=ejercicios.elementAt(numeroEjercicio);
	        	}catch(ArrayIndexOutOfBoundsException ebounds){
	        		checkeable=true;
	        		Toast.makeText(this, "You've finished the test. Please, check it!", Toast.LENGTH_LONG).show(); 
	        		ejercicio=ejercicios.elementAt(numeroEjercicio-1);
	        		numeroPregunta=ejercicio.getPreguntas().size()-1;
	        		Log.d("PreguntaCompletarView","Me desbordo");
	        		
	        	}
	        	
	        	
	        	//2. Dentro del ejercicio, buscamos la pregunta que toca
	        	
	        	pregunta=null;
	        	Vector<Pregunta> preguntas=ejercicio.getPreguntas();
	        	
	        	if(numeroPregunta<preguntas.size()){ //Hay siguiente pregunta
	        		//Cargamos datos el ejercicio pregunta
	        		pregunta=preguntas.elementAt(numeroPregunta);
	        		txtPregunta.setText(pregunta.getEnunciado());
	        		txtRespuesta.setText(pregunta.getRespuestaUsuario());
	        		
	        		//
	        		txtRespuestaCorrecta.setText(pregunta.getRespuesta());
	        		
	        		if(pregunta.getRespuesta().trim().equalsIgnoreCase(pregunta.getRespuestaUsuario().trim())){
	        			//txtRespuestaCorrecta.setBackgroundColor(Color.GREEN);
	        			//capaRespuesta.setBackgroundColor(Color.GREEN);
	        			imgIconoRespuesta.setImageResource(R.drawable.check);
	        		}
	        		else{
	        			//txtRespuestaCorrecta.setBackgroundColor(Color.RED);
	        			//capaRespuesta.setBackgroundColor(Color.RED);
	        			imgIconoRespuesta.setImageResource(R.drawable.error);
	        		}
	     
	        		if(numeroPregunta==(preguntas.size()-1)){
	        			uPregunta=true;
	        			Log.d("PreguntaCompletarView","Ultima pregunta del ejercicio ... incremento el numero de ejercicio");
	        		}	
	        	}
	        	
	        	
	        	datosAdicionales.setText(ejercicio.getDatosAdicionales());
	        	txtEjercicio.setText(ejercicio.getEnunciado());
	        }
	        
	        
	        
	        if(checkMode){
	        	txtRespuesta.setEnabled(false);
	        	txtRespuestaCorrecta.setVisibility(View.VISIBLE);
	        	imgIconoRespuesta.setVisibility(View.VISIBLE);
	        	capaRespuesta.setVisibility(View.VISIBLE);
	        	
	        }else{
	        	txtRespuestaCorrecta.setVisibility(View.INVISIBLE);
	        	imgIconoRespuesta.setVisibility(View.INVISIBLE);
	        	capaRespuesta.setVisibility(View.INVISIBLE);
	        }
	  
	        
	        Log.d("PreguntaCompletarView","Paso por el onCreate de PreguntarCompletarView");
	       
	    }
	 
	 
	 
	 private Vector getEjercicios(){
		 leccionAdapter=new LeccionAdapter(getApplicationContext());
		 Vector<Ejercicio> ejercicios=leccionAdapter.getEjercicios(1);
		 
		 for(int i=0;i<ejercicios.size();i++){
			 Ejercicio e=ejercicios.elementAt(i);
			 
			 Vector<Pregunta> preguntas=e.getPreguntas();
			 
			 for(int j=0;j<preguntas.size();j++){
				 Pregunta p=preguntas.elementAt(j);
				 
				 System.out.println("Pregunta: "+p.toString());
				 
			 }
			 
			 System.out.println(e.getEnunciado());
		 }
		 
		 return ejercicios;
			
	}
	 
	 @Override
	    public boolean onCreateOptionsMenu(Menu menu) {
	        getMenuInflater().inflate(R.menu.menu_test, menu);
	        return true;
	    }
	    
	    
	    @Override
	    public boolean onOptionsItemSelected(MenuItem item) {
	    	
	    	Intent intento=null;
	    	boolean lanzar=true;
	    	
	        switch (item.getItemId()) {
	            case R.id.MnuOpc7: 
	            	
	            	uPregunta=false;
	            	
	            	//Grabamos la respuesta
	            	String jj=txtRespuesta.getText().toString();
	            	pregunta.setRespuestaUsuario(jj);
	            	
	            	if(numeroPregunta>0) PreguntaCompletarView.numeroPregunta--;
	            	else{
	            		if(numeroEjercicio>0){
	            			numeroEjercicio--;
	            			ejercicio=ejercicios.elementAt(numeroEjercicio);
	            			numeroPregunta=ejercicio.getPreguntas().size()-1;
	            			pregunta=ejercicio.getPreguntas().elementAt(numeroPregunta);
	            		}else{
	            			lanzar=false;
	            			Toast.makeText(this, "You're in the first question!", Toast.LENGTH_LONG).show(); 
	            		}
	            	}
	            	
	            	
	            	intento=new Intent(PreguntaCompletarView.this, PreguntaCompletarView.class);
	            	
	            	intento.putExtra("idLeccion", idLeccion);
	                intento.putExtra("nombreLeccion", nombreLeccion);
	            	
	            	Log.d("MejoraTuIngles","probando..."+PreguntaCompletarView.numeroPregunta);
	                break;
	            case R.id.check:
	            	//Check.
	            	if(checkeable) checkMode=true;
	            	else{
	            		Toast.makeText(this, "You finish the test before correcting!", Toast.LENGTH_LONG).show(); 
	            		lanzar=false;
	            	}
	            	
	            	
	            	
	                intento=new Intent(PreguntaCompletarView.this, PreguntaCompletarView.class);
	                
	                numeroEjercicio=0;
	                numeroPregunta=0;
	                
	                intento.putExtra("idLeccion", idLeccion);
	                intento.putExtra("nombreLeccion", nombreLeccion);
	                
	                
	            	
	                break;
	            case R.id.units:
	            	
	            	intento=new Intent(PreguntaCompletarView.this, ListadoLeccion.class);
	            	break;
	            
	            case R.id.MnuOpc9:
	            	
	            	//Grabamos la respuesta
	            	String r=txtRespuesta.getText().toString();
	            	pregunta.setRespuestaUsuario(r);
	            	
	            	
	            	
	            	//Avanzar
	            	PreguntaCompletarView.numeroPregunta++;
	            	
	            	
	            	//Si habiamos llegado a la �ltima pregunta del ejercicio
	            	//aumentamos el numero de ejercicio para pasar al siguiente
	            	if(uPregunta){
	            		numeroEjercicio++;
	            		
	            		if(numeroEjercicio>=ejercicios.size()) {
	            			numeroEjercicio--;
	            			numeroPregunta--;
	            			lanzar=false;
	            			checkeable=true;
	            			Toast.makeText(this, "You've finished the test. Please, check it!", Toast.LENGTH_LONG).show(); 
	            		}
	            		
	            		uPregunta=false;
	            		PreguntaCompletarView.numeroPregunta=0;
	            	}
	            	
	            	
	                intento=new Intent(PreguntaCompletarView.this,PreguntaCompletarView.class);
	                
	                intento.putExtra("idLeccion", idLeccion);
	                intento.putExtra("nombreLeccion", nombreLeccion);
	                
	                Log.d("MejoraTuIngles","probando..."+PreguntaCompletarView.numeroPregunta);
	                
	                break;
	            default:
	                return super.onOptionsItemSelected(item);
	        }
	        
	        if(lanzar) startActivity(intento);
	        
	       
	        
	        return true;
	    }
	    
	    public static void inicializar(){
	    	numeroPregunta=0;
	    	numeroEjercicio=0;
	    	
	    	uPregunta=false;
	    	uEjercicio=false;
	    	
	    	checkeable=false;
	    	checkMode=false;
	    	 	
	    	ejercicios=null; //Contenedor de los ejercicios de una lecci�n
	    	
	    }

}
