package es.uoc.mejoratuingles.activities;

import java.util.*;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;
import android.widget.TableLayout;
import android.widget.TableRow;
import android.widget.TextView;
import android.widget.ImageView;
import android.view.Gravity;
import android.content.res.Resources;

import es.uoc.mejoratuingles.db.*;
import es.uoc.mejoratuingles.db.adapters.*;
import es.uoc.mejoratuingles.beans.*;

public class ProgresoView extends Activity {
	
	private LeccionAdapter leccionAdapter=null;
	
	TableLayout tabla;
	TableLayout cabecera;
	TableRow.LayoutParams layoutFila;
	TableRow.LayoutParams layoutId;
	TableRow.LayoutParams layoutTexto;
	TableRow.LayoutParams layoutAcademic;

	private int MAX_FILAS = 10;

	Resources rs;
	
	
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.progreso_layout);
        rs = this.getResources();
        tabla = (TableLayout)findViewById(R.id.tabla);
        cabecera = (TableLayout)findViewById(R.id.cabecera);
        layoutFila = new TableRow.LayoutParams(TableRow.LayoutParams.WRAP_CONTENT,TableRow.LayoutParams.WRAP_CONTENT);
        layoutId = new TableRow.LayoutParams(200,TableRow.LayoutParams.WRAP_CONTENT);
        layoutTexto = new TableRow.LayoutParams(120,TableRow.LayoutParams.WRAP_CONTENT);
        layoutTexto = new TableRow.LayoutParams(120,TableRow.LayoutParams.WRAP_CONTENT);
        
        agregarCabecera();
        agregarFilasTabla();
    }

    public void agregarCabecera(){
     TableRow fila;
     TextView txtId;
     TextView txtNombre;
     TextView txtAcademic;

     fila = new TableRow(this);
 fila.setLayoutParams(layoutFila);

 txtId = new TextView(this);
 txtNombre = new TextView(this);
 txtAcademic = new TextView(this);

 txtId.setText(rs.getString(R.string.id));
 txtId.setGravity(Gravity.CENTER_HORIZONTAL);
 txtId.setTextAppearance(this,R.style.etiqueta);
 txtId.setBackgroundResource(R.drawable.tabla_celda_cabecera);
 txtId.setLayoutParams(layoutId);

 txtNombre.setText(rs.getString(R.string.completado));
 txtNombre.setGravity(Gravity.CENTER_HORIZONTAL);
 txtNombre.setTextAppearance(this,R.style.etiqueta);
 txtNombre.setBackgroundResource(R.drawable.tabla_celda_cabecera);
 txtNombre.setLayoutParams(layoutTexto);
 
 txtAcademic.setText(rs.getString(R.string.notas));
 txtAcademic.setGravity(Gravity.CENTER_HORIZONTAL);
 txtAcademic.setTextAppearance(this,R.style.etiqueta);
 txtAcademic.setBackgroundResource(R.drawable.tabla_celda_cabecera);
 txtAcademic.setLayoutParams(layoutTexto);

 fila.addView(txtId);
 fila.addView(txtNombre);
 fila.addView(txtAcademic);
 
 
 cabecera.addView(fila);
    }

    
    public void agregarFilasTabla(){

        TableRow fila;
        TextView txtId;
        TextView txtNombre;
        ImageView p;
        TextView txtAcademic;
        
        leccionAdapter=new LeccionAdapter(getApplicationContext());
        
        List<Leccion> lecciones=leccionAdapter.getAllLeccion();
        
        Iterator i=lecciones.iterator();
        StringBuffer b=new StringBuffer();
        
        
       //TableLayout tabla=(TableLayout)findViewById(R.layout.progreso_layout.);
        
        
        	
        	
        	
        
        
     

        while(i.hasNext()){
        	Leccion l=(Leccion)i.next();
        	Log.i("ProgresoView",l.toString());
        	
            
            fila = new TableRow(this);
            fila.setLayoutParams(layoutFila);

            txtId = new TextView(this);
            txtNombre = new TextView(this);
            txtAcademic = new TextView(this);
            p=new ImageView(this);

            txtId.setText(l.getNombre());
            txtId.setGravity(Gravity.CENTER_HORIZONTAL);
            txtId.setTextAppearance(this,R.style.etiqueta);
            txtId.setBackgroundResource(R.drawable.tabla_celda);
            txtId.setLayoutParams(layoutId);
            
            
            if(l.getCompletada()==0) p.setImageResource(R.drawable.icon_non_verified);
            else p.setImageResource(R.drawable.icon_verified);
           // p.setGravity(Gravity.CENTER_HORIZONTAL);
          //  p.setTextAppearance(this,R.style.etiqueta);
            p.setBackgroundResource(R.drawable.tabla_celda);
            p.setLayoutParams(layoutTexto);

            String resultados;
            
            if(l.getResultadoTest()<0) resultados="--";
            else resultados=l.getResultadoTest()+"%";
            
            txtAcademic.setText(resultados);
            txtAcademic.setGravity(Gravity.CENTER_HORIZONTAL);
            txtAcademic.setTextAppearance(this,R.style.etiqueta);
            txtAcademic.setBackgroundResource(R.drawable.tabla_celda);
            txtAcademic.setLayoutParams(layoutTexto);


            fila.addView(txtId);
            fila.addView(p);
            fila.addView(txtAcademic);

            tabla.addView(fila);
        }
        
        leccionAdapter.close();
       }
	
	
	
	
	
/*	 @Override

	    public void onCreate(Bundle savedInstanceState) {

	        super.onCreate(savedInstanceState);
	        setContentView(R.layout.progreso_layout);
	        
	        leccionAdapter=new LeccionAdapter(getApplicationContext());
	        
	        List<Leccion> lecciones=leccionAdapter.getAllLeccion();
	        
	        Iterator i=lecciones.iterator();
	        
	        StringBuffer b=new StringBuffer();
	        
	        
	       //TableLayout tabla=(TableLayout)findViewById(R.layout.progreso_layout.);
	        
	        while(i.hasNext()){
	        	Leccion l=(Leccion)i.next();
	        	Log.i("ProgresoView",l.toString());
	        	
	        	
	        }
	        
	        leccionAdapter.close();
	        
	        
	    }*/
	 
	 @Override
	    public boolean onCreateOptionsMenu(Menu menu) {
	        getMenuInflater().inflate(R.menu.menu_progreso, menu);
	        return true;
	    }
	    
	    
	    @Override
	    public boolean onOptionsItemSelected(MenuItem item) {
	    	
	    	Intent intento=null;
	    	
	    	
	        switch (item.getItemId()) {
	            case R.id.prog_lecciones:     
	            	intento=new Intent(ProgresoView.this, ListadoLeccion.class);
	                break;
	            case R.id.prog_ayuda:
	                intento=new Intent(ProgresoView.this, AyudaView.class);
	                break;
	            
	            default:
	                return super.onOptionsItemSelected(item);
	        }
	        
	        startActivity(intento);
	        
	       
	        
	        return true;
	    }

}
