package es.uoc.mejoratuingles.db;

import java.util.*;

//import es.guia.interfaz.Menus;
import es.uoc.mejoratuingles.activities.R;
import android.content.Context;
import android.content.res.AssetManager;
import android.content.res.Resources;
import android.database.Cursor;
import android.database.sqlite.*;
import android.database.sqlite.SQLiteDatabase.*;
import android.util.Log;

import es.uoc.mejoratuingles.beans.*;
import es.uoc.mejoratuingles.util.*;



public class MejoraTuInglesDatabaseHelper extends SQLiteOpenHelper {
	public static final String PREGUNTA="PREGUNTA"; //Subpregunta dentro del ejercicio
	public static final String EJERCICIO="EJERCICIO"; //Ejercicios de la leccin
	public static final String LECCION="LECCION"; //Almacn de lecciones
	public static final String DATABASE_NAME="MejoraTuIngles";
	public static final int DATABASE_VERSION=8;
	
	private Context context=null;
	
	public MejoraTuInglesDatabaseHelper(Context context, String databaseName, CursorFactory factory, int version) {
		super(context, databaseName, factory, version);
		this.context=context;
		
		Log.d("[MejoraTuIngles]","Constructor GuiaDatabaseHelper");
	}
	
	public MejoraTuInglesDatabaseHelper(Context context){
		super(context,DATABASE_NAME,null,DATABASE_VERSION);
		this.context=context;
	}

	@Override
	public void onCreate(SQLiteDatabase db) {
		
		int idEjercicio=0;
		
		
		Log.d("[MejoraTuIngles]","Ejecutando el script de creacion con modificaciones");
		
		//Script completo de creacin de BBDD.
		db.execSQL("CREATE  TABLE \""+LECCION+"\" (\"ID\" INTEGER PRIMARY KEY  AUTOINCREMENT NOT NULL , \"NOMBRE\" VARCHAR NOT NULL  UNIQUE, \"URL\" VARCHAR NOT NULL  UNIQUE, \"COMPLETADA\" INTEGER, \"RESULTADO_TEST\" DOUBLE );");
		db.execSQL("CREATE  TABLE \""+EJERCICIO+"\" (\"id\" INTEGER PRIMARY KEY  AUTOINCREMENT NOT NULL ,\"id_leccion\" INTEGER, \"enunciado\" VARCHAR NOT NULL , \"datos_adicionales\" VARCHAR, \"calificacion\" VARCHAR,  FOREIGN KEY(id_leccion) REFERENCES LECCION (id));");
		db.execSQL("CREATE  TABLE \""+PREGUNTA+"\" (\"id\" INTEGER PRIMARY KEY  AUTOINCREMENT NOT NULL ,\"id_ejercicio\" INTEGER, \"enunciado\" VARCHAR NOT NULL , \"respuesta\" VARCHAR NOT NULL,  FOREIGN KEY(id_ejercicio) REFERENCES EJERCICIO (id));");
				
		
		//Lecciones catalogadas
		if(context.getResources().getXml(R.xml.lecciones)==null) Log.i("[MejoraTuIngles]", "El xmlresources es nulo");
		XMLReaderHelper xmlHelper=new XMLReaderHelper(context.getResources().getXml(R.xml.lecciones));
		Vector<Leccion> listaLecciones=xmlHelper.getLecciones();
		
		for(int i=0;i<listaLecciones.size();i++){
			Leccion p=listaLecciones.elementAt(i);
			String sql="insert into "+LECCION+" (nombre,url,completada,resultado_test) values "
				+"('"+p.getNombre()+"'"
				+",'"+p.getUrl()+"',0,-1)";
				
			Log.d("[MejoraTuIngles]",sql);
			db.execSQL(sql);
			
			//Insercin de ejercicios asociados
			
			Vector<Ejercicio> ejercicios=p.getEjercicios();
			for(int k=0;k<ejercicios.size();k++){
				/*String query = "SELECT MAX(id) AS max_id FROM EJERCICIO";
				Cursor cursor = db.rawQuery(query, null);
				cursor.moveToFirst();
				
				int idEjercicio = cursor.getInt(0);*/
				idEjercicio++;
				Ejercicio e = ejercicios.elementAt(k);
				
				sql="insert into "+EJERCICIO+" (id, id_leccion, enunciado,datos_adicionales) values "
						+"(" 
						+idEjercicio
						+","+(i+1)
						+",'"+e.getEnunciado()+
						"','"+e.getDatosAdicionales()+"')";
				
				db.execSQL(sql);
				Log.i("[MejoraTuIngles]","Insertado ejercicio con id: "+idEjercicio+" enunciado: "+e.getEnunciado());
				
				Vector<Pregunta> preguntas=e.getPreguntas();
				
				if(preguntas==null) break;
				
				for(int j=0;j<preguntas.size();j++){
					Pregunta pr=preguntas.elementAt(j);
					sql="insert into "+PREGUNTA+" (id_ejercicio, enunciado, respuesta) values "
							+"('"+idEjercicio+"','"
							+pr.getEnunciado()+"'"
							+",'"+pr.getRespuesta()+"')";
					
					db.execSQL(sql);
					Log.i("[MejoraTuIngles]","Insertada pregunta con idEjercicio: "+idEjercicio+" enunciado: "+pr.getEnunciado());
				}
			}
		}
		
		
		Log.d("[MejoraTuIngles]","Se ha recreado el modelo correctamente CON test");
		
	}

	@Override
	public void onUpgrade(SQLiteDatabase db, int version, int newVersion) {
		Log.d("MejoraTuIngles","Existe un cambio de versin en BBDD. Preparado para actualizar.");
		
		// TODO Auto-generated method stub
		 db.execSQL("DROP TABLE IF EXISTS "+LECCION);
		 db.execSQL("DROP TABLE IF EXISTS "+EJERCICIO);
		 db.execSQL("DROP TABLE IF EXISTS "+PREGUNTA);
		 
		 Log.d("DEBUG","Base de datos borrada");
		 
		 onCreate(db);
	}
	
}

