package es.uoc.mejoratuingles.util;

import java.util.Vector;

import org.xmlpull.v1.XmlPullParser;

import android.content.res.Resources;
import android.content.res.XmlResourceParser;
import android.util.Log;
import es.uoc.mejoratuingles.beans.*;
import es.uoc.mejoratuingles.activities.R;

public class XMLReaderHelper {
	private XmlResourceParser xmlFile=null;
	
	public XMLReaderHelper(XmlResourceParser xmlFile){
		this.xmlFile=xmlFile;
		
	}
	
	public Vector<Leccion> getLecciones(){
		Vector<Leccion> listaLecciones=new Vector<Leccion>();
		Vector<Ejercicio> ejercicios = new Vector<Ejercicio>();
		Vector<Pregunta> preguntas = new Vector<Pregunta>();
		
		
		//XmlResourceParser xmlFile = resources.getXml(R.xml.lista_pois);
		
		try{
			xmlFile.next();//Get next parse event
			int eventType = xmlFile.getEventType(); //Get current xml event i.e., START_DOCUMENT etc.
			
			Leccion leccion=null;
			Ejercicio ejercicio=null;
			Pregunta pregunta=null;
			
			
			while (eventType != XmlPullParser.END_DOCUMENT){  
				
				
			    if(eventType == XmlPullParser.START_DOCUMENT){     
			        Log.i("MejoraTuIngles","Comienza la lectura de unidades lectivas");
			    }else if(eventType == XmlPullParser.START_TAG){
			    	
			    	
			    	String nameTag=xmlFile.getName();
			    	
			    	
			    	if(nameTag.equals("leccion")){
			    		String nombre=xmlFile.getAttributeValue(0);
			    		String url=xmlFile.getAttributeValue(1);
			    		
			    		leccion=new Leccion();
			    		leccion.setNombre(nombre);
			    		leccion.setUrl(url);
			    		
			    		ejercicios=new Vector<Ejercicio>();
			    		preguntas=new Vector<Pregunta>();
			    		
			    		Log.d("[MejoraTuIngles]", "Leccion encontrada: "+nombre+"   "+url);
			    		
						
			    	}else if(nameTag.equals("enunciadoGeneral")){
			    		ejercicio=new Ejercicio();
			    		xmlFile.next();
			    		String enunciado=xmlFile.getText();
			    		ejercicio.setEnunciado(enunciado);
			    		
			    	}else if(nameTag.equals("pregunta")){
			    		pregunta=new Pregunta();
			    	}else if(nameTag.equals("ejercicio")){
			    		preguntas=new Vector<Pregunta>();
			    	}else if(nameTag.equals("enunciado")){
			    		xmlFile.next();
			    		pregunta.setEnunciado(xmlFile.getText());
			    	}else if(nameTag.equals("respuesta")){
			    		xmlFile.next();
			    		pregunta.setRespuesta(xmlFile.getText());
			    	}else if(nameTag.equals("datosAdicionales")){
			    		xmlFile.next();
			    		ejercicio.setDatosAdicionales(xmlFile.getText());
			    	}
			    }else if(eventType==XmlPullParser.TEXT){
			    	Log.d("MejoraTuIngles",xmlFile.getText());
			    }else if(eventType==XmlPullParser.END_TAG){
			    	if(xmlFile.getName().equals("leccion")){
			    		//A�adir a la lista
			    		Log.d("MejoraTuIngles","Cerrando leccion: "+leccion.toString()); 		
			    		leccion.setEjercicios(ejercicios);
			    		listaLecciones.add(leccion);
			    		
			    		ejercicios=null;
			    		preguntas=null;
			    
			    	}else if(xmlFile.getName().equals("enunciadoGeneral")){
			    		
			    	}else if(xmlFile.getName().equals("pregunta")){
			    		preguntas.add(pregunta);
			    	}else if(xmlFile.getName().equals("ejercicio")){
			    		ejercicio.setPreguntas(preguntas);
			    		ejercicios.add(ejercicio);
			    		preguntas=null;
			    	}
			    }
			    
			    xmlFile.next();
			    eventType=xmlFile.getEventType();
			}
		}catch(Exception e){
			Log.e("MejoraTuIngles",e.toString());
		}
		
		Log.i("MejoraTuIngles","Resumen de lecciones leidas");
		Log.i("MejoraTuIngles","======================\n");
		for(int i=0;i<listaLecciones.size();i++){
			Leccion a=listaLecciones.elementAt(i);
			Log.i("[MejoraTuIngles]",a.toString());
		}
		
		return listaLecciones;
	}

}
